public class DownloadController {
    //创建进度条
    //必须要定义为全局变量,这样前台才能访问进度,且一个用户一个进度
    private ProgressBarThread  pbt;

    /**
     * @author 佳。
     * @date 2016年3月11日
     * @Description: 获取进度
     * @param: @param request
     * @param: @param response 
     * @return void  
     * @throws
     */
    @RequestMapping("total")
    public void text1(HttpServletRequest request , HttpServletResponse response){
        //设置输出文本格式
        response.setContentType("application/json;charset=utf-8");
        //获取进度
        String total = pbt.total();
        //创建JSON
        JSONObject json = new JSONObject();
        //存储进度
        json.put("total", total);
        try {
            //向前台返回进度
            response.getWriter().write(json.toJSONString());
        } catch (IOException e) {
            e.printStackTrace();
        }
    }


    /**
     * @author 佳。
     * @date 2016年3月11日
     * @Description: 跳转至下载页面
     * @param: @param request
     * @param: @return 
     * @return String  
     * @throws
     */
    @RequestMapping("text")
    public String text(HttpServletRequest request){
        return "text/text";
    }

    /**
     * @author 佳。
     * @date 2016年3月7日
     * @Description: 文件下载
     * @param: @param fileName 文件名称
     * @return String  返回值为null
     * @throws
     */
    @RequestMapping(value = "download")
    public void download(String fileName, HttpServletRequest request,
            HttpServletResponse response) {
        response.setCharacterEncoding("utf-8");
        response.setContentType("multipart/form-data");
        response.setHeader("Content-Disposition", "attachment;fileName="
                + fileName);

        try {
            //  /WEB-INF/download文件夹的根目录
            String path = request.getSession().
                    getServletContext().getRealPath("/WEB-INF/download");

            // 获取相应文件的流
            // File.separator(Windows系统为'/')
            File file = new File(path + File.separator + fileName);
            //创建进度条
            pbt = new ProgressBarThread((int)file.length());
            //开启线程，刷新进度条
            new Thread(pbt).start();

            //设置文件长度
            response.setHeader("Content-Length", (int)file.length()+"");
            //IO流复制
            InputStream inputStream = new FileInputStream(file);
            OutputStream os = response.getOutputStream();
            byte[] b = new byte[2048];
            int length;
            while ((length = inputStream.read(b)) > 0) {
                os.write(b, 0, length);
                //写完一次，更新进度条
                pbt.updateProgress(length);
            }
            //文件读取完成，关闭进度条
            pbt.finish();
            // 释放资源 
            os.close();

            inputStream.close();
        } catch (FileNotFoundException e) {
            e.printStackTrace();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
}